// Imports
import * as PartyModel from "/services/model/party-model.js";
import * as AreaModel from "/services/model/area-model.js";

export async function mount(parent) {
  const mapComponent = new MapComponent(parent);
  return mapComponent;
}

class MapComponent {
  constructor(parent) {
    this.parent = parent;
    this.PartyModel = PartyModel.getPartyModel();
    this.AreaModel = AreaModel.getAreaModel();
  }

  async displayMapAreas() {
    console.log("mount area map")
    await this.initMap("/assets/maps/area.json", this.colorAreas);
  }

  async displayMapSections() {
    console.log("mount section map")
    await this.initMap("/assets/maps/section.json", this.colorSections);
  }

  async initMap(mapFile, colorationFunction) {
    // Create datasource
    const request = new XMLHttpRequest();
    request.open("GET", mapFile, false);
    request.send(null);
    let dataSource = JSON.parse(request.responseText);

      // Add parties and colors to datasource
      dataSource = await colorationFunction(dataSource);

    document.getElementById("map-component").innerHTML = "";
    // Create a popup, but don't add it to the map yet.
    let popup = new mapboxgl.Popup({
      closeButton: false,
    });

    const map = new mapboxgl.Map({
      container: "map-component", // container id
      style: "/assets/mapbox/vector.json", // stylesheet location
      center: [4.9, 45.75], // starting position [lng, lat]
      zoom: 9.7, // starting zoom
    });

    // map.on("load", function () {
    //   map.addSource("data-source", {
    //     type: "geojson",
    //     data: dataSource,
    //   });

    //   map.addLayer(
    //     {
    //       id: "winners-fills",
    //       type: "fill",
    //       source: "data-source",
    //       layout: {},
    //       paint: {
    //         "fill-color": { type: "identity", property: "color" },
    //         "fill-opacity": 0.5,
    //         "fill-outline-color": "black",
    //       },
    //     },
    //     "place_label_city"
    //   );

    //   map.addLayer({
    //     id: "winners-names",
    //     type: "symbol",
    //     source: "data-source",
    //     filter: ["all"],
    //     layout: {
    //       "text-field": "{partyName}",
    //       "text-font": ["titiliumweb-regular"],
    //     },
    //   });
    // });
  }

  async colorAreas(dataSource) {}

  async colorSections(dataSource) {}
}
