export function scrollInit(divName, autoScrollCheckbox) {
  let scroller = new Scroller(divName, autoScrollCheckbox);
  return scroller;
}

class Scroller {
  constructor(divName, autoScrollCheckbox) {
    this.elmnt = document.getElementById(divName);
    this.autoScrollCheckbox = autoScrollCheckbox;
    this.reachedMaxScroll = false;

    this.elmnt.scrollTop = 0;
    this.previousScrollTop = 0;

    this.elmnt.addEventListener("mouseover", () => {
      if (autoScrollCheckbox.checked) this.pauseScroll();
    });
    this.elmnt.addEventListener("mouseout", () => {
      if (autoScrollCheckbox.checked) this.resumeScroll();
    });

    this.autoScrollCheckbox.addEventListener("change", () => {
      if (autoScrollCheckbox.checked) this.resumeScroll();
      else this.pauseScroll();
    });
  }

  scrollDiv() {
    if (this.autoScrollCheckbox.checked) {
      if (!this.reachedMaxScroll) {
        this.elmnt.scrollBy({ top: 5, left: 0, behavior: "smooth" });
        this.reachedMaxScroll =
          this.elmnt.scrollTop >=
          this.elmnt.scrollHeight - this.elmnt.offsetHeight;
      } else {
        this.reachedMaxScroll = this.elmnt.scrollTop == 0 ? false : true;
        this.elmnt.scrollBy({ top: -5, left: 0, behavior: "smooth" });
      }
      this.scrollTimeout = setTimeout(() => {
        this.scrollDiv();
      }, 100);
    }
  }

  pauseScroll() {
    clearInterval(this.scrollTimeout);
  }

  resumeScroll() {
    this.scrollDiv();
  }
}
